#!/bin/bash
# Script en el lado del servidor que intentará hacer el registro de un cliente
# Éste script es llamado al recibir una conexión de un cliente
# Para ello leeará del socket a la espera de un dato válido (IP CID)
# y comprobará si la información es correcta. 
# En el caso que lo sea establercerá el estado como activo y notificará al cliente con un ACTIVE
# En otro caso devoverá un FAIL
# Requerimientos: 
# - sipcalc
# - Token de autorización del servidor migasfree con permisos de "server|Ordenador|* (los 4 permisos que hay: add, save, change y delete)
# Para lanzar el demonio que atienda las conexiones (pendiente de dejar los logs en directorio de forma oraganizada):
# ncat -l -k -p 54321 -vv -o /var/log/vitalinux/cambio-estado.log --append-output 2>> /var/log/vitalinux/conex-cambio-estado.log -c '/var/vitalinux/server_status.sh'
set_status_active(){
	# Funcion que activa el cliente en migasfree
	SERVER="migasfree.educa.aragon.es"
	TOKEN="0b2d6459cb5f3c961941f13d1619b5a10de14e6f"
	# Comprobar primero si el equipo está en estado de baja u otro que no mole...no queremos
	# que por error un equipo de baja se pueda poner directamente activo
	# 
	local ESTADO=$(curl -s -i -H "Authorization: Token ${TOKEN}" http://${SERVER}:80/api/v1/token/computers/${1}/ )
	echo "$ESTADO" | grep '"detail":"Not found."' > /dev/null 2>&1 && echo "FAIL - CID: $1 no encontrado" && return 1
	echo "$ESTADO" | grep '"status":"unsubscribed"' > /dev/null 2>&1 && echo "FAIL - CID: $1 esta de baja" && return 1
	# Cambio de estado
	if curl -s -i -X POST -H "Authorization: Token ${TOKEN}" -H "Content-Type: application/json" \
	  -d '{"status":"intended"}' \
	  http://${SERVER}:80/api/v1/token/computers/${1}/status/ | grep '"status":"intended"' > /dev/null 2>&1 ; then
		return 0
	else
		return 1
	fi
}
read LINE
IPCLIENTE=$(echo "${LINE}" | cut -d ' '  -f1)
CIDSOLICITUD=$(echo "${LINE}" | cut -d ' '  -f2)
if sipcalc "$IPCLIENTE" | grep "ERR"  > /dev/null 2>&1 ; then
	echo "FAIL"
	exit 1
fi 
SSH_OP="-q -o PasswordAuthentication=no -o StrictHostKeyChecking=no -o ConnectTimeout=3"
if  CIDREAL=$(ssh $SSH_OP root@$IPCLIENTE migasfree-cid); then
	if [[ "$CIDREAL" != "$CIDSOLICITUD" ]]; then
		echo "FAIL - CID no coincide"
		exit 1
	fi
	if set_status_active "$CIDREAL" ; then
		echo "ACTIVE"
		exit 0
	else
		echo "FAIL - Fallo en migasfree cambio de estado"
		exit 1
	fi
else
	echo "FAIL - No check CID"
	exit 1
fi 
#ncat -l -k -p 3333 --recv-only -vv -o peticiones_ncat 2> conex_ncat | while read LINE; do echo "He leido esto $LINE y me espero 5 seg"; sleep 5;  done
